project/manager_frontend/urls.py
from django.conf.urls import url
from django.views.generic import TemplateView

from .views import HomeView
from .views.config import RecalboxConfigFormView
from .views.logs import LogsView
from .views.bios import BiosListView, BiosUploadJsonView
from .views.roms import RomListView, RomUploadJsonView
#from .views.saves import SavesListView
from .views.systems import SystemsListView
from .views.monitor import MonitoringView
from .views.moonlight import RecalboxMoonlightFormView

urlpatterns = [
    url(r'^$', HomeView.as_view(), name='home'),
    
    url(r'^bios/$', BiosListView.as_view(), name='bios'),
    url(r'^bios/upload$', BiosUploadJsonView.as_view(), name='bios-upload'),
    
    url(r'^config/$', RecalboxConfigFormView.as_view(), name='config'),
    
    url(r'^monitoring/$', MonitoringView.as_view(), name='monitoring'),
    
    url(r'^logs/$', LogsView.as_view(), name='logs'),
    
    url(r'^systems/$', SystemsListView.as_view(), name='roms-systems'),

    url(r'^moonlight/$', RecalboxMoonlightFormView.as_view(), name='moonlight'),
    
    #url(r'^systems/roms/saves/$', SavesListView.as_view(), name='roms-saves-list'),
    
    url(r'^systems/roms/(?P<system>\w+)/$', RomListView.as_view(), name='roms-list'),
    url(r'^systems/roms/(?P<system>\w+)/upload/$', RomUploadJsonView.as_view(), name='roms-upload'),

]

project/urls.py
from django.conf import settings
from django.conf.urls import patterns, include, url
from django.contrib import admin
from django.views.generic import TemplateView

# Discover crumbs from enabled apps
import autobreadcrumbs
autobreadcrumbs.autodiscover()

# Load asset manifest in memory
from project import assets_cartographer
assets_cartographer.autodiscover()

# Load Recalbox manifest in memory
from project import recalbox_manifest
recalbox_manifest.autodiscover()

urlpatterns = [
    #url(r'^admin/', include(admin.site.urls)),
    url(r'^', include('project.manager_frontend.urls', namespace='manager')),
    #url(r'^api/', include('project.api.urls', namespace='api')),
]

# Debug
#if settings.DEBUG:
urlpatterns = patterns('',
    url(r'^media/(?P<path>.*)$', 'django.views.static.serve',
        {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}),
    url(r'^500/$', TemplateView.as_view(template_name="500.html")),
    url(r'^404/$', TemplateView.as_view(template_name="404.html")),
    url(r'', include('django.contrib.staticfiles.urls')),
) + urlpatterns

project/manager_frontend/models.py
#from django.db import models

## Create your models here.

project/manager_frontend/utils/views.py
"""
Some common class based views
"""
import json

from django.views.generic.edit import TemplateResponseMixin, FormMixin, ProcessFormView

class MultiFormView(TemplateResponseMixin, FormMixin, ProcessFormView):
    """
    This is a huge rewrite and mixing of some CBV views and mixins to be able 
    to distinctly manage multiple forms in the same view
    
    The view can implement some custom method for some forms that will be used 
    during ProcessFormView process.
    
    Forms have to implement a 'form_key' and 'form_fieldname_trigger' 
    attributes.
    
    The first is the key name to use to build form object name (in view 
    context) and build optional custom view methods. 
    
    The second is the name attribute of the input watched to know if the form 
    is triggered like with a submit button.
    
    Both must be unique through the forms of the view.
    
    TODO: This view should implement some warnings about needed stuff like 
          form attributes and form object names if not defined. So actually 
          you'll have to remember of this yourself.
    """
    # The patterns used to find method/names from form 'form_key' attribute
    getformkwargs_pattern = 'get_{}_form_kwargs'
    formvalid_pattern = '{}_form_valid'
    formobject_pattern = '{}_form'
    
    def get_form(self, form_class=None, empty=False):
        """
        Returns an instance of the form to be used in this view.
        
        Modified to give the 'form_class' to 'get_form_kwargs' and accept 'empty' arg
        """
        if form_class is None:
            form_class = self.get_form_class()
        return form_class(**self.get_form_kwargs(form_class, empty=empty))
    
    def get_form_kwargs(self, form_class=None, empty=False):
        """
        Returns the keyword arguments for instantiating the form. Basically the 
        kwargs are the same for all forms.
        
        Accept 'form_class' and 'empty' optionnal args
        
        'empty' argument purpose is to enforce unbound form (so only the triggered 
        form is bound)
        
        In the end, try to use the custom method 'get_KEY_form_kwargs' for the 
        given form where 'KEY' is the form 'form_key' attribute. The method is 
        given the current kwargs and must return it (modified or not)
        """
        kwargs = {
            'initial': self.get_initial(),
            'prefix': self.get_prefix(),
        }

        if not empty and self.request.method in ('POST', 'PUT'):
            kwargs.update({
                'data': self.request.POST,
                'files': self.request.FILES,
            })
        
        # Try custom form method
        if form_class:
            form_key = form_class.form_key
            if hasattr(self, self.getformkwargs_pattern.format(form_key)):
                kwargs = getattr(self, self.getformkwargs_pattern.format(form_key))(kwargs)
        
        return kwargs

    def form_valid(self, form):
        """
        Use the custom form method if any, returns either the custom form method return if 
        not None or the default View response
        """
        form_key = form.form_key
        if hasattr(self, self.formvalid_pattern.format(form_key)):
            resp = getattr(self, self.formvalid_pattern.format(form_key))(form)
            # If the XXX_form_valid method does not return None, assume it's a Response
            if resp is not None:
                return resp
            
        return super(MultiFormView, self).form_valid(form)

    def form_invalid(self, *args):
        """
        Fill context with all given forms
        """
        forms = {}
        for form in args:
            key = self.formobject_pattern.format(form.form_key)
            forms[key] = form
        
        return self.render_to_response(self.get_context_data(**forms))
        
    def get(self, request, *args, **kwargs):
        """
        Just initialize enabled forms as unbounded
        """
        # Add all enabled forms to the view context as initialized 
        # unbounded form
        forms = {}
        for form_class in self.enabled_forms:
            key = self.formobject_pattern.format(form_class.form_key)
            forms[key] = self.get_form(form_class)
        
        return self.render_to_response(self.get_context_data(**forms))
    
    def post(self, request, *args, **kwargs):
        """
        Initialize enabled forms but only the one its submit is triggered will 
        be bounded, other are still unbounded
        """
        forms = []
        triggered_form = None
        for form_class in self.enabled_forms:
            # From default, forms are all empty but the triggered one
            empty = True
            if self.request.POST.get(form_class.form_fieldname_trigger):
                empty = False
            # Init form and append it
            form_instance = self.get_form(form_class, empty=empty)
            forms.append(form_instance)
            # Retain the triggered
            if self.request.POST.get(form_class.form_fieldname_trigger):
                triggered_form = form_instance
        
        # Check if triggered form is valid or not
        if triggered_form and triggered_form.is_valid():
            return self.form_valid(triggered_form)
        else:
            return self.form_invalid(*forms)

project/manager_frontend/views/bios.py
"""
Views for Bios views
"""
import os
from operator import itemgetter

from django.conf import settings
from django.core.urlresolvers import reverse
from django.contrib import messages
from django.http import Http404, HttpResponseBadRequest
from django.utils.translation import ugettext as _

from project.utils.views import JsonMixin

from project.recalbox_manifest import manifest as RECALBOX_MANIFEST

from project.manager_frontend.forms.bios import BiosDeleteForm, BiosUploadForm
from project.manager_frontend.utils.views import MultiFormView

class BiosListView(MultiFormView):
    """
    List supported Bios from Recalbox manifest
    
    Include an upload form to add valid bios file and a delete form to remove 
    some existing bios.
    """
    template_name = "manager_frontend/bios_list.html"
    enabled_forms = (BiosUploadForm, BiosDeleteForm)
            
    def init_manifest(self):
        self.bios_manifest = self.get_bios_manifest()
        self.existing_bios_files = self.get_existing_bios_list()

    def get_existing_bios_list(self):
        """
        Walk into Bios directory to find existing files for knowed bios (from manifest)
        """
        path = settings.RECALBOX_BIOS_PATH
        bios_dir_files = [item for item in os.listdir(path) if os.path.isfile(os.path.join(path, item)) and not item.startswith('.')]
        
        for md5hash,values in self.bios_manifest.items():
            filename,system,exist = values
            if filename in bios_dir_files:
                values[2] = True
        
        return bios_dir_files
    
    def get_bios_manifest(self):
        """
        Open the manifest to find knowed bios files
        """
        bios_dict = {}
        
        for system_key, system_datas in RECALBOX_MANIFEST.items():
            system_name = system_datas.get('name', system_key)
            if len(system_datas.get('bios', []))>0:
                for md5hash,filename in system_datas['bios']:
                    bios_dict[md5hash] = [filename, system_name, False]
                
        return bios_dict
            
    def get_bios_choices(self):
        rom_list = []
        
        for md5hash,values in self.bios_manifest.items():
            rom_list.append( (md5hash, values[0]) )
        
        return tuple( sorted(rom_list, key=itemgetter(1)) )
    
    def get_context_data(self, **kwargs):
        context = super(BiosListView, self).get_context_data(**kwargs)
        context.update({
            'bios_path': settings.RECALBOX_BIOS_PATH,
            'bios_manifest': self.bios_manifest,
            'existing_bios_files': self.existing_bios_files,
            'existing_bios_length': len([True for md5hash,values in self.bios_manifest.items() if values[2]]),
        })
        return context
            
    def get_upload_form_kwargs(self, kwargs):
        kwargs.update({'bios_manifest': self.bios_manifest})
        return kwargs
    
    def get_delete_form_kwargs(self, kwargs):
        kwargs.update({'bios_choices': self.get_bios_choices()})
        return kwargs
        
    def upload_form_valid(self, form):
        uploaded_file = form.save()
        
        # Throw a message to tell about upload success
        messages.success(self.request, _('File has been uploaded: {}').format(os.path.basename(uploaded_file)))
            
    def delete_form_valid(self, form):
        deleted_files = form.save()
        if deleted_files and len(deleted_files)>0:
            deleted_files = ", ".join([os.path.basename(item) for item in deleted_files])
            # Throw a message to tell about deleted files
            messages.success(self.request, _('Deleted file(s): {}').format( deleted_files ))

    def get_success_url(self):
        return reverse('manager:bios')
        
    def get(self, request, *args, **kwargs):
        self.init_manifest()
        return super(BiosListView, self).get(request, *args, **kwargs)
    
    def post(self, request, *args, **kwargs):
        self.init_manifest()
        return super(BiosListView, self).post(request, *args, **kwargs)


class BiosUploadJsonView(JsonMixin, BiosListView):
    """
    Inherit from BiosListView to be similary but gives only response in JSON
    
    Also the delete form should not really be used here
    """
    def upload_form_valid(self, form):
        """
        Return a dummy success response suitable to Dropzone plugin
        """
        uploaded_file = form.save()
        
        return self.json_response({'status': 'success'})

    def form_invalid(self, *args):
        """
        Tricky error JSON response for upload
        
        This is a naive implementation than assume this is only about bios upload 
        form errors.
        """
        forms_errors = {'error': 'Unknow error occured'}
        error_msg = ''
        
        for form in args:
            # Bother only about upload form
            if form.form_key == 'upload':
                errs = form.errors.as_data()
                # Get error(s), potentially compact them if more than one message
                if 'bios' in errs:
                    error_context = [str(item.message) for item in errs['bios']]
                    if len(error_context) > 1:
                        error_msg = "\n".join(error_context)
                    elif len(error_context) == 1:
                        error_msg = "".join(error_context)
            else:
                continue
        
        if error_msg:
            forms_errors['error'] = error_msg
        
        return self.json_response(forms_errors, response_klass=HttpResponseBadRequest)

project/manager_frontend/views/config.py
"""
Views for configuration files
"""
import os

from django.conf import settings
from django.views.generic.edit import FormView
from django.core.urlresolvers import reverse
from django.contrib import messages
from django.utils.translation import ugettext as _

from project.manager_frontend.forms.config import ConfigEditForm

class RecalboxConfigFormView(FormView):
    """
    Display a form to edit the Recalbox config file
    """
    template_name = "manager_frontend/config_form.html"
    form_class = ConfigEditForm

    def dispatch(self, request, *args, **kwargs):
        self.config_filepath = settings.RECALBOX_CONF_PATH
        self.config_content = self.get_config_file(self.config_filepath)
        
        self.backup_filepath = settings.RECALBOX_CONF_BACKUP_PATH
        self.backup_content = None
        if os.path.exists(self.backup_filepath):
            self.backup_content = self.get_config_file(self.backup_filepath)
        
        return super(RecalboxConfigFormView, self).dispatch(request, *args, **kwargs)
            
    def get_config_file(self, filepath):
        content = None
            
        if filepath:
            with open(filepath, 'rb') as file:
                content = file.read()
        
        return content
    
    def get_context_data(self, **kwargs):
        context = super(RecalboxConfigFormView, self).get_context_data(**kwargs)
        context.update({
            'config_filepath': self.config_filepath,
            'config_content': self.config_content,
            'backup_filepath': self.backup_filepath,
            'backup_content': self.backup_content,
        })
        return context

    def get_success_url(self):
        return reverse('manager:config')
            
    def get_form_kwargs(self):
        context = super(RecalboxConfigFormView, self).get_form_kwargs()
        context.update({
            'config_filepath': self.config_filepath,
            'backup_filepath': self.backup_filepath,
        })
        return context
    
    def get_initial(self):
        """
        Returns the initial data to use for forms on this view.
        """
        return {
            'content': self.config_content,
        }

    def form_valid(self, form):
        new_content, is_backuped = form.save()
        
        # Throw a message to tell about upload success
        if is_backuped:
            messages.success(self.request, _('File has been backuped then edited'))
        else:
            messages.success(self.request, _('File has been edited'))
        
        return super(RecalboxConfigFormView, self).form_valid(form)

project/manager_frontend/views/logs.py
"""
Views for logs files
"""
from django.conf import settings
from django.views.generic import TemplateView

class LogsView(TemplateView):
    template_name = "manager_frontend/logs_detail.html"
            
    def get_logs_file(self):
        content = None
        
        with open(settings.RECALBOX_LOGFILE_PATH, 'rb') as file:
            content = file.read()
            
        return content
    
    def get_context_data(self, **kwargs):
        context = super(LogsView, self).get_context_data(**kwargs)
        context.update({
            'logs_filepath': settings.RECALBOX_LOGFILE_PATH,
            'logs_content': self.get_logs_file(),
        })
        return context

project/manager_frontend/templates/manager_frontend/base.html
{% extends "skeleton.html" %}
{% load autobreadcrumb %}

{% block head_title %}{% current_title_from_breadcrumbs %} - {{ block.super }}{% endblock %}

{% block base_content %}
<div class="row larger manager_frontend">
    <div class="small-12 columns">{% spaceless %}
        {% block breadcrumbs_block %}{% autobreadcrumbs_tag %}{% endblock %}
        {% block manager_title %}<h1>{% current_title_from_breadcrumbs %}</h1>{% endblock %}
        {% block manager_content %}{% endblock %}
    {% endspaceless %}</div>
</div>
{% endblock %}

project/manager_frontend/templates/manager_frontend/bios_list.html
{% extends "manager_frontend/base.html" %}
{% load i18n manager_tags assets %}

{% block page_more_js %}{{ block.super }}
    {% javascript_tag "js/dropzone.min.js" %}
    <script type="text/javascript">
    //<![CDATA[
        Dropzone.options['uploadDropzone'] = {
            'init': function() {
                // Naive usage of queuecomplete event
                // Should be aware of upload errors and so don't automatically 
                // reload the page (displaying a warning?)
                this.on("queuecomplete", function() {
                    //window.location.href = '{% url 'manager:bios' %}';
                });
            },
            'url': "{% url 'manager:bios-upload' %}",
            'paramName': "{{ upload_form.bios.name }}"
        };
    //]]>
    </script>
{% endblock %}


{% block manager_content %}
<ul class="inline-list">
    <li><span class="label info radius">{% trans "Path" %}: {{ bios_path }}</span></li>
    <li><span class="label info radius">{% trans "Total" %}: {{ existing_bios_length }}</span></li>
</ul>

<form action="{% url 'manager:bios' %}" method="post" id="upload-dropzone" class="dropzone" enctype="multipart/form-data">
    {% csrf_token %}
    <input type="hidden" name="upload_submit" value="1">
    <div class="fallback">
        <div class="row">
            <div class="large-12 columns">
                <div class="row collapse">
                    {% if messages %}{% for message in messages %}
                    <div class="alert-box{% if message.tags %} {{ message.tags }}{% endif %}" data-alert>
                        {{ message }}
                        <a href="#" class="close">&times;</a>
                    </div>
                    {% endfor %}{% endif %}
                    
                    {% if upload_form.bios.errors %}
                    <div class="small-12 columns">
                        {% for error in upload_form.bios.errors %}
                        <small class="error">{{ error }}</small>
                        {% endfor %}
                    </div>
                    {% endif %}
                    
                    <div class="small-3 columns">
                        <span class="prefix">{% trans "Upload a bios" %}</span>
                    </div>
                    <div class="small-7 columns">
                        {{ upload_form.bios }}
                    </div>
                    <div class="small-2 columns">
                        <input type="submit" name="upload_submit" value="Send" class="button postfix">
                    </div>
                </div>
            </div>
        </div>
    </div>
</form>

<form action="." method="post">
    {% csrf_token %}
    {% if delete_form.roms.errors %}
    <div class="row">
        <div class="small-12 columns">
            {% for error in delete_form.roms.errors %}
            <small class="error">{{ error }}</small>
            {% endfor %}
        </div>
    </div>
    {% endif %}
    
    <div class="row">
        <div class="small-12 medium-9 columns">
            <p class="tiny-button-v-align">{% blocktrans %}This is the full list of supported Bios, existing bios you have uploaded will be decorated and followed with a checkbox{% endblocktrans %}</p>
        </div>
        <div class="small-12 medium-3 columns text-right">
            <input type="submit" name="delete_submit" value="{% trans "Delete selected files" %}" class="button tiny radius info">
        </div>
    </div>
    
    <div class="text-right">
        <table class="expand">
            <thead>
                <tr>
                    <th class="text-right"><small>#</small></th>
                    <th>{% trans "System" %}</th>
                    <th>{% trans "Filename" %}</th>
                    <th>{% trans "MD5 checksum" %}</th>
                    <th class="text-center">{% trans "Check" %}</th>
                </tr>
            </thead>
            <tbody>
            {% for checkbox in delete_form.bios_files %}{% with manifest_entry=bios_manifest|get_item:checkbox.choice_value %}
                <tr class="{% if manifest_entry.2 %}active{% else %}disabled{% endif %}">
                    <td class="text-right"><small>{{ forloop.counter }}</small></td>
                    <td>{{ manifest_entry.1 }}</td>
                    <td>{{ checkbox.choice_label }}</td> {% comment %}filename{% endcomment %}
                    <td>{{ checkbox.choice_value }}</td> {% comment %}-> md5{% endcomment %}
                    <td class="text-center">{% if manifest_entry.2 %}{{ checkbox.tag }}{% else %}&nbsp;{% endif %}</td>
                </tr>
            {% endwith %}{% endfor %}
            </tbody>
        </table>
        <input type="submit" name="delete_submit" value="{% trans "Delete selected files" %}" class="button tiny radius info">
    </div>
</form>
{% endblock %}

project/manager_frontend/templates/manager_frontend/home.html
{% extends "manager_frontend/base.html" %}
{% load i18n %}

{% block breadcrumbs_block %}{% endblock %}

{% block manager_title %}{% endblock %}

{% block manager_content %}
<div class="dashboard-icons">
    <div class="flex-grid marged">
        <a href="{% url 'manager:monitoring' %}" class="cell small-98 medium-48 large-31 button reverse-primary large radius text-center">
            <i class="icon-bar-chart icon-4x icon-block"></i>
            <p>
                {% blocktrans %}<strong>Monitor</strong> your system resources{% endblocktrans %}
            </p>
        </a>
        <a href="{% url 'manager:config' %}" class="cell small-98 medium-48 large-31 button reverse-primary large radius text-center">
            <i class="icon-cogs icon-4x icon-block"></i>
            <p>
                {% blocktrans %}Read and edit the Recalbox <strong>Configuration</strong> file{% endblocktrans %}
            </p>
        </a>
        <a href="{% url 'manager:logs' %}" class="cell small-98 medium-48 large-31 button reverse-primary large radius text-center">
            <i class="icon-book icon-4x icon-block"></i>
            <p>
                {% blocktrans %}Read the Recalbox <strong>logs</strong>{% endblocktrans %}
            </p>
        </a>
        <a href="{% url 'manager:bios' %}" class="cell small-98 medium-48 large-31 button reverse-primary large radius text-center">
            <i class="icon-nes-console icon-4x icon-block"></i>
            <p>
                {% blocktrans %}Manage all supported <strong>Bios</strong> files for emulated systems{% endblocktrans %}
            </p>
        </a>
        <a href="{% url 'manager:roms-systems' %}" class="cell small-98 medium-48 large-31 button reverse-primary large radius text-center">
            <i class="icon-nes-cartridge icon-4x icon-block"></i>
            <p>
                {% blocktrans %}Manage <strong>Rom</strong> files for emulated systems{% endblocktrans %}
            </p>
        </a>
        <a href="http://{{ SITE.hostname }}:8080" target="_blank" class="cell small-98 medium-48 large-31 button reverse-primary large radius text-center">
            <i class="icon-gamepad icon-4x icon-block"></i>
            <p>
                {% blocktrans %}Use the <strong>Virtual gamepad</strong>{% endblocktrans %}
            </p>
        </a>
    </div>
</div>
{% endblock %}

project/manager_frontend/templates/manager_frontend/rom_list.html
{% extends "manager_frontend/base.html" %}
{% load i18n assets %}

{% block page_more_js %}{{ block.super }}
    {% javascript_tag "js/dropzone.min.js" %}
    <script type="text/javascript">
    //<![CDATA[
        Dropzone.options['uploadDropzone'] = {
            'init': function() {
                // Naive usage of queuecomplete event
                // Should be aware of upload errors and so don't automatically 
                // reload the page (displaying a warning?)
                this.on("queuecomplete", function() {
                    window.location.href = '{% url 'manager:roms-list' system=system %}';
                });
            },
            'url': "{% url 'manager:roms-upload' system=system %}",
            'paramName': "{{ upload_form.rom.name }}"
        };
    //]]>
    </script>
{% endblock %}


{% block manager_content %}
<ul class="inline-list">
    <li><span class="label info radius">{% trans "Path" %}: {{ system_path }}</span></li>
    <li><span class="label info radius">{% trans "Total" %}: {{ total_roms }}</span></li>
</ul>

{% with bios_checking=view.check_system_bios %}
{% if bios_checking %}
<div data-alert class="alert-box warning radius">
    {% url 'manager:bios' as bios_url %}
    <p><strong>{% blocktrans with bios_url=bios_url %}This system requires one or more <a href="{{ bios_url }}">bios</a> file that are missing from your installation:{% endblocktrans %}</strong></p>
    <p><strong>{{ bios_checking|join:', ' }}</strong></p>
</div>
{% endif %}
{% endwith %}

<form action="{% url 'manager:roms-list' system=system %}" method="post" id="upload-dropzone" class="dropzone" enctype="multipart/form-data">
    {% csrf_token %}
    <input type="hidden" name="upload_submit" value="1">
    <div class="fallback">
        <div class="row">
            <div class="large-12 columns">
                <div class="row collapse">
                    {% if messages %}{% for message in messages %}
                    <div class="alert-box{% if message.tags %} {{ message.tags }}{% endif %}" data-alert>
                        {{ message }}
                        <a href="#" class="close">&times;</a>
                    </div>
                    {% endfor %}{% endif %}
                    
                    {% if upload_form.rom.errors %}
                    <div class="small-12 columns">
                        {% for error in upload_form.rom.errors %}
                        <small class="error">{{ error }}</small>
                        {% endfor %}
                    </div>
                    {% endif %}
                    
                    <div class="small-3 columns">
                        <span class="prefix">{% trans "Upload a rom" %}</span>
                    </div>
                    <div class="small-7 columns">
                        {{ upload_form.rom }}
                    </div>
                    <div class="small-2 columns">
                        <input type="submit" name="upload_submit" value="Send" class="button postfix">
                    </div>
                </div>
            </div>
        </div>
    </div>
</form>

<form action="." method="post">
    {% csrf_token %}
    {% if delete_form.roms.errors %}
    <div class="row">
        <div class="small-12 columns">
            {% for error in delete_form.roms.errors %}
            <small class="error">{{ error }}</small>
            {% endfor %}
        </div>
    </div>
    {% endif %}
    
    <div class="text-right">
        <input type="submit" name="delete_submit" value="{% trans "Delete selected files" %}" class="button tiny radius info">
        <table class="expand">
            <thead>
                <tr>
                    <th class="text-right"><small>#</small></th>
                    <th>{% trans "Filename" %}</th>
                    <th>{% trans "Size" %}</th>
                    <th class="text-center">{% trans "Check" %}</th>
                </tr>
            </thead>
            <tbody>
            {% for checkbox in delete_form.roms %}
                <tr>
                    <td class="text-right"><small>{{ forloop.counter }}</small></td>
                    <td>{{ checkbox.choice_value }}</td>
                    <td>{{ checkbox.choice_label|filesizeformat }}</td>
                    <td class="text-center">{{ checkbox.tag }}</td>
                </tr>
            {% endfor %}
            </tbody>
        </table>
        <input type="submit" name="delete_submit" value="{% trans "Delete selected files" %}" class="button tiny radius info">
    </div>
</form>
{% endblock %}

project/manager_frontend/templates/manager_frontend/systems_list.html
{% extends "manager_frontend/base.html" %}
{% load i18n %}

{% block manager_content %}
<ul class="inline-list">
    <li><span class="label info radius">{% trans "Path" %}: {{ systems_path }}</span></li>
    <li><span class="label info radius">{% trans "Total" %}: {{ systems_list|length }}</span></li>
</ul>

{% if available_systems %}<form action="." method="post">
    {% csrf_token %}
    <div class="row">
        <div class="large-12 columns">
            <div class="row collapse">
                {% if messages %}{% for message in messages %}
                <div class="alert-box{% if message.tags %} {{ message.tags }}{% endif %}" data-alert>
                    {{ message }}
                    <a href="#" class="close">&times;</a>
                </div>
                {% endfor %}{% endif %}
                
                {% if form.name.errors %}
                <div class="small-12 columns">
                    {% for error in form.name.errors %}
                    <small class="error">{{ error }}</small>
                    {% endfor %}
                </div>
                {% endif %}
                
                <div class="small-3 columns">
                    <span class="prefix">{% trans "Available systems" %}</span>
                </div>
                <div class="small-7 columns">
                    {{ form.name }}
                </div>
                <div class="small-2 columns">
                    <input type="submit" name="submit" value="{% trans "Add" %}" class="button postfix">
                </div>
            </div>
        </div>
    </div>
</form>{% endif %}


<div class="flex-grid marged systems-list">{% for key,name in systems_list %}
    <a href="{% url 'manager:roms-list' system=key %}" class="cell small-58 large-23 folder text-center flex-vertical-center-stack button large radius">
        <i class="icon-folder icon-4x"></i> {{ name }}
    </a>
{% endfor %}</div>
{% endblock %}